#!/usr/bin/perl -w

# $Header: /raid/cvsroot/rt/bin/Attic/testdeps.pl,v 1.1.2.9 2000/06/26 19:10:36 jesse Exp $

# Copyright 2000 Jesse Vincent <jesse@fsck.com>
# Distributed under the GNU General Public License
# 

#
# This is just a basic script that checks to make sure that all
# the modules needed by RT before you can install it.
#

# TODO Polish this a whole lot


use strict;

use vars qw($mode $module @modules);

$mode = shift || &print_help;

@modules = qw(
DBI 1.13
HTML::Mason 0.81
Date::Manip
Time::Seconds
Date::Kronos
MIME::Entity 5.108
Mail::Mailer 1.19
CGI::Cookie 1.06
Log::Dispatch 1.2
HTML::Entities 
Text::Wrapper
DBIx::Handle
DBIx::Record
DBIx::EasySearch
Apache::Session 1.03
);
use CPAN;

while ($module= shift @modules) {
	my $version = "";
	$version = " ". shift (@modules) . " " if ($modules[0] =~ /^([\d\.]*)$/);
	print "Checking for $module$version\n" if ($mode =~ /-w/ );
	eval "use $module$version" ;
	&resolve_dependency($module, $version) if ($@);
}

sub print_help {
print <<EOF;

$0 is a tool for RT that will tell you if you've got all
the modules RT depends on properly installed.

Flags: (only one flag is valid for a given run)

-quiet will check to see if we've got everything we need
	and will exit with a return code of (1) if we don't.

-warn will tell you what isn't properly installed

-fix will use CPAN to magically make everything better

EOF
}

sub resolve_dependency {
	my $module = shift;
	my $version = shift;
        print "$module$version not installed.\n" if ($mode =~ /-w/);
	CPAN::install($module) if ($mode =~ /-f/);
	exit(1) if ($mode =~ /-q/);
}	
	
